#include <fcntl.h>
#include <unistd.h>
#include <string.h>

#define BUFFER_SIZE 5
#define ERROR_BUFFER_SIZE 4096

int main(int argc, char **argv) {
    int fd;
    char buffer[BUFFER_SIZE];
    
    if (argc < 2) {
        char usage[ERROR_BUFFER_SIZE];
        
        // there is an easier way of writing a string in a buffer,
        // see the available functions in string.h
        strcpy(usage, "Usage: ");
        strcat(usage, argv[0]);
        strcat(usage, " FILE\n");
        
        write(STDERR_FILENO, usage, strlen(usage));
        return 1;
    }
    
    fd = open(argv[1], O_RDONLY);
    if (fd < 0) {
        perror(argv[1]);
        return 1;
    }
    
    read(fd, buffer, BUFFER_SIZE);
    
    write(STDOUT_FILENO, buffer, BUFFER_SIZE);
    
    // write an additional newline character
    // write(STDOUT_FILENO, "\n", 1);
    
    int error = close(fd);
    if (error == -1) {
        perror("close()");
        return 1;
    }
    
    return 0;
}

// NOTE: This program is not guaranteed to work correctly - there is some
// error handling but it's not complete!
